Index: issm/trunk/src/m/classes/levelset.js
===================================================================
--- issm/trunk/src/m/classes/levelset.js	(revision 25994)
+++ issm/trunk/src/m/classes/levelset.js	(revision 26744)
@@ -8,7 +8,12 @@
 	this.setdefaultparameters = function(){// {{{
 
-		//stabilization = 2 by default
-		this.stabilization		= 2;
+		//stabilization = 1 by default
+		this.stabilization		= 1;
 		this.reinit_frequency	= 5;
+		this.kill_icebergs      = 1;
+		this.migration_max      = 1e12; //No need for general cases, unless specified
+
+		//Linear elements by default
+		this.fe='P1';
 	
 	}// }}}
@@ -19,10 +24,13 @@
 		fielddisplay(this,'spclevelset','Levelset constraints (NaN means no constraint)');
 		fielddisplay(this,'reinit_frequency','Amount of time steps after which the levelset function in re-initialized (NaN: no re-initialization).');
+		fielddisplay(this,'kill_icebergs','remove floating icebergs to prevent rigid body motions (1: true, 0: false)');
+		fielddisplay(this,'migration_max','maximum allowed migration rate (m/a)');
+		fielddisplay(this,'fe','Finite Element type: "P1" (default), or "P2"');
 
 	}// }}}
-	this.extrude = function(md) {//{{{
-		this.spclevelset=project3d(md,'vector',this.spclevelset,'type','node');
-		return this;
-	}//}}}
+    this.extrude = function(md) {//{{{
+        this.spclevelset=project3d(md,'vector',this.spclevelset,'type','node');
+        return this;
+    }//}}}
 	this.classname= function(){// {{{
 		return "levelset";
@@ -33,21 +41,32 @@
 
 		checkfield(md,'fieldname','levelset.spclevelset','Inf',1,'timeseries',1);
-		checkfield(md,'fieldname','levelset.stabilization','values',[0,1,2]);
+		checkfield(md,'fieldname','levelset.stabilization','values',[0,1,2,5]);
+		checkfield(md,'fieldname','levelset.kill_icebergs','numel',1,'values',[0, 1]);
+		checkfield(md,'fieldname','levelset.migration_max','numel',1,'NaN',1,'Inf',1,'>',0);
+		checkfield(md,'fieldname','levelset.fe','values',['P1','P2']);
 	} //}}}
 	this.marshall=function(md,prefix,fid) { //{{{
+
+		let yts=md.constants.yts;
+
 		WriteData(fid,prefix,'object',this,'fieldname','stabilization','format','Integer');
 		WriteData(fid,prefix,'object',this,'fieldname','spclevelset','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
 		WriteData(fid,prefix,'object',this,'fieldname','reinit_frequency','format','Integer');
-
+		WriteData(fid,prefix,'object',this,'fieldname','kill_icebergs','format','Boolean');
+		WriteData(fid,prefix,'object',this,'fieldname','migration_max','format','Double','scale',1/yts);
+		WriteData(fid,prefix,'object',this,'fieldname','fe','format','String');
 	}//}}}
-	this.fix=function() { //{{{
-		this.spclevelset=NullFix(this.spclevelset,NaN);
-	}//}}}
+		this.fix=function() { //{{{
+			this.spclevelset=NullFix(this.spclevelset,NaN);
+		}//}}}
 	//properties 
 	// {{{
 
 	this.stabilization		= 0;
-	this.spclevelset			= NaN;
+	this.spclevelset		= NaN;
 	this.reinit_frequency	= NaN;
+	this.kill_icebergs     	= 0;
+	this.migration_max      = 0.;
+	this.fe              	= 'P1';
 
 	this.setdefaultparameters();
Index: issm/trunk/src/m/classes/levelset.m
===================================================================
--- issm/trunk/src/m/classes/levelset.m	(revision 25994)
+++ issm/trunk/src/m/classes/levelset.m	(revision 26744)
@@ -9,7 +9,7 @@
 		spclevelset			= NaN;
 		reinit_frequency	= 5;
-		kill_icebergs     = 0;
-		migration_max       = 0.;
-		fe                = 'P1';
+		kill_icebergs		= 0;
+		migration_max		= 0.;
+		fe					= 'P1';
 	end
 	methods
@@ -32,4 +32,13 @@
 			end
 		end % }}}
+		function disp(self) % {{{
+			disp(sprintf('   Level-set parameters:'));
+			fielddisplay(self,'stabilization','0: no, 1: artificial_diffusivity, 2: streamline upwinding');
+			fielddisplay(self,'spclevelset','Levelset constraints (NaN means no constraint)');
+			fielddisplay(self,'reinit_frequency','Amount of time steps after which the levelset function in re-initialized');
+			fielddisplay(self,'kill_icebergs','remove floating icebergs to prevent rigid body motions (1: true, 0: false)');
+			fielddisplay(self,'migration_max','maximum allowed migration rate (m/a)');
+			fielddisplay(self,'fe','Finite Element type: ''P1'' (default), or ''P2''');
+		end % }}}
 		function self = extrude(self,md) % {{{
 
@@ -42,5 +51,5 @@
 			self.reinit_frequency = 5;
 			self.kill_icebergs    = 1;
-			self.migration_max      = 3000.;
+			self.migration_max    = 1e12; % No need for general cases, unless specified
 
 			%Linear elements by default
@@ -53,17 +62,8 @@
 
 			md = checkfield(md,'fieldname','levelset.spclevelset','Inf',1,'timeseries',1);
-			md = checkfield(md,'fieldname','levelset.stabilization','values',[0 1 2]);
+			md = checkfield(md,'fieldname','levelset.stabilization','values',[0 1 2 5]);
 			md = checkfield(md,'fieldname','levelset.kill_icebergs','numel',1,'values',[0 1]);
 			md = checkfield(md,'fieldname','levelset.migration_max','numel',1,'NaN',1,'Inf',1,'>',0);
 			md = checkfield(md,'fieldname','levelset.fe','values',{'P1','P2'});
-		end % }}}
-		function disp(self) % {{{
-			disp(sprintf('   Level-set parameters:'));
-			fielddisplay(self,'stabilization','0: no, 1: artificial_diffusivity, 2: streamline upwinding');
-			fielddisplay(self,'spclevelset','Levelset constraints (NaN means no constraint)');
-			fielddisplay(self,'reinit_frequency','Amount of time steps after which the levelset function in re-initialized');
-			fielddisplay(self,'kill_icebergs','remove floating icebergs to prevent rigid body motions (1: true, 0: false)');
-			fielddisplay(self,'migration_max','maximum allowed migration rate (m/a)');
-			fielddisplay(self,'fe','Finite Element type: ''P1'' (default), or ''P2''');
 		end % }}}
 		function marshall(self,prefix,md,fid) % {{{
@@ -72,5 +72,5 @@
 
 			WriteData(fid,prefix,'object',self,'fieldname','stabilization','format','Integer');
-			WriteData(fid,prefix,'object',self,'fieldname','spclevelset','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
+			WriteData(fid,prefix,'object',self,'fieldname','spclevelset','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',yts);
 			WriteData(fid,prefix,'object',self,'fieldname','reinit_frequency','format','Integer');
 			WriteData(fid,prefix,'object',self,'fieldname','kill_icebergs','format','Boolean');
Index: issm/trunk/src/m/classes/levelset.py
===================================================================
--- issm/trunk/src/m/classes/levelset.py	(revision 25994)
+++ issm/trunk/src/m/classes/levelset.py	(revision 26744)
@@ -1,54 +1,48 @@
+import numpy as np
+
+from checkfield import checkfield
 from fielddisplay import fielddisplay
 from project3d import project3d
-from checkfield import checkfield
 from WriteData import WriteData
 
 
 class levelset(object):
-    """
-    LEVELSET class definition
+    """LEVELSET class definition
 
-       Usage:
-          levelset = levelset()
+    Usage:
+        levelset = levelset()
     """
 
     def __init__(self):  # {{{
-
         self.stabilization = 0
-        self.spclevelset = float('NaN')
-        self.reinit_frequency = 0
+        self.spclevelset = np.nan
+        self.reinit_frequency = 5
         self.kill_icebergs = 0
-        self.migration_max = 0.
+        self.migration_max = 0
         self.fe = 'P1'
 
-    #set defaults
+        # Set defaults
         self.setdefaultparameters()
-
     #}}}
     def __repr__(self):  # {{{
-        string = '   Level - set parameters:'
-        string = "%s\n%s" % (string, fielddisplay(self, 'stabilization', '0: no, 1: artificial_diffusivity, 2: streamline upwinding'))
-        string = "%s\n%s" % (string, fielddisplay(self, 'spclevelset', 'levelset constraints (NaN means no constraint)'))
-        string = "%s\n%s" % (string, fielddisplay(self, 'reinit_frequency', 'Amount of time steps after which the levelset function in re-initialized'))
-        string = "%s\n%s" % (string, fielddisplay(self, 'kill_icebergs', 'remove floating icebergs to prevent rigid body motions (1: true, 0: false)'))
-        string = "%s\n%s" % (string, fielddisplay(self, 'migration_max', 'maximum allowed migration rate (m / a)'))
-        string = "%s\n%s" % (string, fielddisplay(self, 'fe', 'Finite Element type: ''P1'' (default), or ''P2'''))
+        s = '   Level-set parameters:\n'
+        s += '{}\n'.format(fielddisplay(self, 'stabilization', '0: no, 1: artificial_diffusivity, 2: streamline upwinding'))
+        s += '{}\n'.format(fielddisplay(self, 'spclevelset', 'Levelset constraints (NaN means no constraint)'))
+        s += '{}\n'.format(fielddisplay(self, 'reinit_frequency', 'Amount of time steps after which the levelset function in re-initialized'))
+        s += '{}\n'.format(fielddisplay(self, 'kill_icebergs', 'remove floating icebergs to prevent rigid body motions (1: true, 0: false)'))
+        s += '{}\n'.format(fielddisplay(self, 'migration_max', 'maximum allowed migration rate (m/a)'))
+        s += '{}\n'.format(fielddisplay(self, 'fe', 'Finite Element type: \'P1\' (default), or \'P2\''))
 
-        return string
-    #}}}
-
-    def extrude(self, md):  # {{{
-        self.spclevelset = project3d(md, 'vector', self.spclevelset, 'type', 'node')
-        return self
+        return s
     #}}}
 
     def setdefaultparameters(self):  # {{{
-        #stabilization = 1 by default
+        # Stabilization = 1 by default
         self.stabilization = 1
         self.reinit_frequency = 5
         self.kill_icebergs = 1
-        self.migration_max = 3000.
+        self.migration_max = 1e12 # No need for general cases, unless specified
 
-    #Linear elements by default
+        # Linear elements by default
         self.fe = 'P1'
 
@@ -57,10 +51,10 @@
 
     def checkconsistency(self, md, solution, analyses):  # {{{
-        #Early return
+        # Early return
         if (solution != 'TransientSolution') or (not md.transient.ismovingfront):
             return md
 
         md = checkfield(md, 'fieldname', 'levelset.spclevelset', 'Inf', 1, 'timeseries', 1)
-        md = checkfield(md, 'fieldname', 'levelset.stabilization', 'numel', [1], 'values', [0, 1, 2])
+        md = checkfield(md, 'fieldname', 'levelset.stabilization', 'numel', [1], 'values', [0, 1, 2, 5])
         md = checkfield(md, 'fieldname', 'levelset.kill_icebergs', 'numel', [1], 'values', [0, 1])
         md = checkfield(md, 'fieldname', 'levelset.migration_max', 'numel', [1], 'NaN', 1, 'Inf', 1, '>', 0)
@@ -69,4 +63,9 @@
         return md
     # }}}
+
+    def extrude(self, md):  # {{{
+        self.spclevelset = project3d(md, 'vector', self.spclevelset, 'type', 'node')
+        return self
+    #}}}
 
     def marshall(self, prefix, md, fid):  # {{{
@@ -77,5 +76,5 @@
         WriteData(fid, prefix, 'object', self, 'fieldname', 'reinit_frequency', 'format', 'Integer')
         WriteData(fid, prefix, 'object', self, 'fieldname', 'kill_icebergs', 'format', 'Boolean')
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'migration_max', 'format', 'Double', 'scale', 1. / yts)
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'migration_max', 'format', 'Double', 'scale', 1 / yts)
         WriteData(fid, prefix, 'object', self, 'fieldname', 'fe', 'format', 'String')
     # }}}
Index: issm/trunk/src/m/classes/lovenumbers.m
===================================================================
--- issm/trunk/src/m/classes/lovenumbers.m	(revision 25994)
+++ issm/trunk/src/m/classes/lovenumbers.m	(revision 26744)
@@ -9,5 +9,5 @@
 classdef lovenumbers
 	properties (SetAccess=public) 
-		
+
 		%regular love numbers:
 		h           = []; %provided by PREM model
@@ -16,8 +16,12 @@
 		
 		%tidal love numbers for computing rotational feedback:
-		th          = []; 
-		tk          = []; 
-		tl          = []; 
-		tk2secular  = 0;  %deg 2 secular number.
+		th          = [];
+		tk          = [];
+		tl          = [];
+		tk2secular  = 0; %deg 2 secular number.
+
+		%time/frequency for visco-elastic love numbers
+		timefreq    = [];
+		istime      = 1;
 
 	end
@@ -29,6 +33,22 @@
 			self=setdefaultparameters(self,maxdeg,referenceframe);
 		end % }}}
+		function disp(self) % {{{
+			disp(sprintf('   lovenumbers parameters:'));
+
+			fielddisplay(self,'h','load Love number for radial displacement');
+			fielddisplay(self,'k','load Love number for gravitational potential perturbation');
+			fielddisplay(self,'l','load Love number for horizontal displacements');
+
+			fielddisplay(self,'th','tidal load Love number (deg 2)');
+			fielddisplay(self,'tk','tidal load Love number (deg 2)');
+			fielddisplay(self,'tl','tidal load Love number (deg 2)');
+			fielddisplay(self,'tk2secular','secular fluid Love number');
+
+			fielddisplay(self,'istime','time (default: 1) or frequency love numbers (0)');
+			fielddisplay(self,'timefreq','time/frequency vector (yr or 1/yr)');
+
+		end % }}}
 		function self = setdefaultparameters(self,maxdeg,referenceframe) % {{{
-		
+
 			%initialize love numbers:
 			self.h=getlovenumbers('type','loadingverticaldisplacement','referenceframe',referenceframe,'maxdeg',maxdeg);
@@ -42,9 +62,12 @@
 			self.tk2secular=0.942; 
 
+			%time: 
+			self.istime=1; %temporal love numbers by default
+			self.timefreq=0; %elastic case by default.
 
 		end % }}}
 		function md = checkconsistency(self,md,solution,analyses) % {{{
 
-			if ~ismember('SealevelriseAnalysis',analyses) | (strcmp(solution,'TransientSolution') & md.transient.isslr==0), 
+			if ~ismember('SealevelchangeAnalysis',analyses) | (strcmp(solution,'TransientSolution') & md.transient.isslc==0), 
 				return; 
 			end
@@ -57,5 +80,8 @@
 			md = checkfield(md,'fieldname','solidearth.lovenumbers.th','NaN',1,'Inf',1);
 			md = checkfield(md,'fieldname','solidearth.lovenumbers.tk','NaN',1,'Inf',1);
+			md = checkfield(md,'fieldname','solidearth.lovenumbers.tl','NaN',1,'Inf',1);
 			md = checkfield(md,'fieldname','solidearth.lovenumbers.tk2secular','NaN',1,'Inf',1);
+			md = checkfield(md,'fieldname','solidearth.lovenumbers.timefreq','NaN',1,'Inf',1);
+			md = checkfield(md,'fieldname','solidearth.lovenumbers.istime','NaN',1,'Inf',1,'values',[0 1]);
 
 			%check that love numbers are provided at the same level of accuracy: 
@@ -64,20 +90,12 @@
 			end
 
+			ntf=length(self.timefreq);
+			if( size(self.h,2) ~= ntf | size(self.k,2) ~= ntf | size(self.l,2) ~= ntf | size(self.th,2) ~= ntf | size(self.tk,2) ~= ntf | size(self.tl,2) ~= ntf ),
+				error('lovenumbers error message: love numbers should have as many time/frequency steps as the time/frequency vector');
+			end
 
 		end % }}}
 		function list=defaultoutputs(self,md) % {{{
 			list = {};
-		end % }}}
-		function disp(self) % {{{
-			disp(sprintf('   lovenumbers parameters:'));
-
-			fielddisplay(self,'h','load Love number for radial displacement');
-			fielddisplay(self,'k','load Love number for gravitational potential perturbation');
-			fielddisplay(self,'l','load Love number for horizontal displacements');
-
-			fielddisplay(self,'th','tidal load Love number (deg 2)');
-			fielddisplay(self,'tk','tidal load Love number (deg 2)');
-			fielddisplay(self,'tk2secular','secular fluid Love number');
-
 		end % }}}
 		function marshall(self,prefix,md,fid) % {{{
@@ -92,4 +110,12 @@
 			WriteData(fid,prefix,'object',self,'data',self.tk2secular,'fieldname','lovenumbers.tk2secular','format','Double');
 
+			if self.istime,
+				scale=md.constants.yts; 
+			else
+				scale=1.0/md.constants.yts;
+			end
+			WriteData(fid,prefix,'object',self,'fieldname','istime','name','md.solidearth.lovenumbers.istime','format','Boolean');
+			WriteData(fid,prefix,'object',self,'fieldname','timefreq','name','md.solidearth.lovenumbers.timefreq','format','DoubleMat','mattype',1,'scale',scale);
+
 		end % }}}
 		function savemodeljs(self,fid,modelname) % {{{
@@ -97,4 +123,6 @@
 			writejs1Darray(fid,[modelname '.lovenumbers.k'],self.k);
 			writejs1Darray(fid,[modelname '.lovenumbers.l'],self.l);
+			writejs1Darray(fid,[modelname '.lovenumbers.istime'],self.istime);
+			writejs1Darray(fid,[modelname '.lovenumbers.time'],self.time);
 		end % }}}
 		function self = extrude(self,md) % {{{
Index: issm/trunk/src/m/classes/lovenumbers.py
===================================================================
--- issm/trunk/src/m/classes/lovenumbers.py	(revision 25994)
+++ issm/trunk/src/m/classes/lovenumbers.py	(revision 26744)
@@ -1,4 +1,3 @@
 import numpy as np
-
 from checkfield import checkfield
 from fielddisplay import fielddisplay
@@ -8,17 +7,20 @@
 
 
-class lovenumbers(object): #{{{
+class lovenumbers(object):  #{{{
     """LOVENUMBERS class definition
 
     Usage:
-        lovenumbers = lovenumbers() #will setup love numbers deg 1001 by default
-        lovenumbers = lovenumbers('maxdeg', 10001);  #supply numbers of degrees required (here, 10001)
+        lovenumbers = lovenumbers()
+        lovenumbers = lovenumbers('maxdeg', 10000, 'referenceframe', 'CF');
+
+    Choose numbers of degrees required (1000 by default) and reference frame 
+    (between CF and CM; CM by default)
     """
 
-    def __init__(self, *args): #{{{
+    def __init__(self, *args):  #{{{
         # Regular love numbers
-        self.h = []  # Provided by PREM model
-        self.k = []  # idem
-        self.l = []  # idem
+        self.h = []   # Provided by PREM model
+        self.k = []   # idem
+        self.l = []   # idem
 
         # Tidal love numbers for computing rotational feedback
@@ -26,5 +28,9 @@
         self.tk = []
         self.tl = []
-        self.tk2secular = 0 # deg 2 secular number
+        self.tk2secular = 0  # deg 2 secular number
+
+        # Time/frequency for visco-elastic love numbers
+        self.timefreq = []
+        self.istime = 1
 
         options = pairoptions(*args)
@@ -34,20 +40,38 @@
     #}}}
 
-    def setdefaultparameters(self, maxdeg, referenceframe): #{{{
+    def __repr__(self):  #{{{
+        s = '   lovenumbers parameters:\n'
+        s += '{}\n'.format(fielddisplay(self, 'h', 'load Love number for radial displacement'))
+        s += '{}\n'.format(fielddisplay(self, 'k', 'load Love number for gravitational potential perturbation'))
+        s += '{}\n'.format(fielddisplay(self, 'l', 'load Love number for horizontal displacements'))
+        s += '{}\n'.format(fielddisplay(self, 'th', 'tidal load Love number (deg 2)'))
+        s += '{}\n'.format(fielddisplay(self, 'tk', 'tidal load Love number (deg 2)'))
+        s += '{}\n'.format(fielddisplay(self, 'tl', 'tidal load Love number (deg 2)'))
+        s += '{}\n'.format(fielddisplay(self, 'tk2secular', 'secular fluid Love number'))
+        s += '{}\n'.format(fielddisplay(self, 'istime', 'time (default: 1) or frequency love numbers (0)'))
+        s += '{}\n'.format(fielddisplay(self, 'timefreq', 'time/frequency vector (yr or 1/yr)'))
+        return s
+    #}}}
+
+    def setdefaultparameters(self, maxdeg, referenceframe):  #{{{
         # Initialize love numbers
-        self.h = getlovenumbers('type', 'loadingverticaldisplacement', 'referenceframe', referenceframe, 'maxdeg', maxdeg)
-        self.k = getlovenumbers('type', 'loadinggravitationalpotential', 'referenceframe', referenceframe, 'maxdeg', maxdeg)
-        self.l = getlovenumbers('type', 'loadinghorizontaldisplacement', 'referenceframe', referenceframe, 'maxdeg', maxdeg)
-        self.th = getlovenumbers('type', 'tidalverticaldisplacement', 'referenceframe', referenceframe, 'maxdeg', maxdeg)
-        self.tk = getlovenumbers('type', 'tidalgravitationalpotential', 'referenceframe', referenceframe, 'maxdeg', maxdeg)
-        self.tl = getlovenumbers('type', 'tidalhorizontaldisplacement', 'referenceframe', referenceframe, 'maxdeg', maxdeg)
+        self.h = getlovenumbers('type', 'loadingverticaldisplacement', 'referenceframe', referenceframe, 'maxdeg', maxdeg).reshape(-1,1)
+        self.k = getlovenumbers('type', 'loadinggravitationalpotential', 'referenceframe', referenceframe, 'maxdeg', maxdeg).reshape(-1,1)
+        self.l = getlovenumbers('type', 'loadinghorizontaldisplacement', 'referenceframe', referenceframe, 'maxdeg', maxdeg).reshape(-1,1)
+        self.th = getlovenumbers('type', 'tidalverticaldisplacement', 'referenceframe', referenceframe, 'maxdeg', maxdeg).reshape(-1,1)
+        self.tk = getlovenumbers('type', 'tidalgravitationalpotential', 'referenceframe', referenceframe, 'maxdeg', maxdeg).reshape(-1,1)
+        self.tl = getlovenumbers('type', 'tidalhorizontaldisplacement', 'referenceframe', referenceframe, 'maxdeg', maxdeg).reshape(-1,1)
 
         # Secular fluid love number
         self.tk2secular = 0.942
+
+        # Time
+        self.istime = 1 # Temporal love numbers by default
+        self.timefreq = np.zeros(1) # Elastic case by default
         return self
     #}}}
 
-    def checkconsistency(self, md, solution, analyses): #{{{
-        if ('SealevelriseAnalysis' not in analyses) or (solution == 'TransientSolution' and not md.transient.isslr):
+    def checkconsistency(self, md, solution, analyses):  #{{{
+        if ('SealevelchangeAnalysis' not in analyses) or (solution == 'TransientSolution' and not md.transient.isslc):
             return
         md = checkfield(md, 'fieldname', 'solidearth.lovenumbers.h', 'NaN', 1, 'Inf', 1)
@@ -57,27 +81,25 @@
         md = checkfield(md, 'fieldname', 'solidearth.lovenumbers.th', 'NaN', 1, 'Inf', 1)
         md = checkfield(md, 'fieldname', 'solidearth.lovenumbers.tk', 'NaN', 1, 'Inf', 1)
+        md = checkfield(md, 'fieldname', 'solidearth.lovenumbers.tl', 'NaN', 1, 'Inf', 1)
         md = checkfield(md, 'fieldname', 'solidearth.lovenumbers.tk2secular', 'NaN', 1, 'Inf', 1)
+        md = checkfield(md, 'fieldname', 'solidearth.lovenumbers.timefreq', 'NaN', 1, 'Inf', 1)
+        md = checkfield(md, 'fieldname', 'solidearth.lovenumbers.istime', 'NaN', 1, 'Inf', 1, 'values', [0, 1])
+
         # Check that love numbers are provided at the same level of accuracy
         if (self.h.shape[0] != self.k.shape[0]) or (self.h.shape[0] != self.l.shape[0]):
             raise ValueError('lovenumbers error message: love numbers should be provided at the same level of accuracy')
+
+        ntf = len(self.timefreq)
+        if (np.shape(self.h)[1] != ntf or np.shape(self.k)[1] != ntf or np.shape(self.l)[1] != ntf or np.shape(self.th)[1] != ntf or np.shape(self.tk)[1] != ntf or np.shape(self.tl)[1] != ntf):
+            raise ValueError('lovenumbers error message: love numbers should have as many time/frequency steps as the time/frequency vector')
+
         return md
     #}}}
 
-    def defaultoutputs(self, md): #{{{
+    def defaultoutputs(self, md):  #{{{
         return[]
     #}}}
 
-    def __repr__(self): #{{{
-        s = '   lovenumbers parameters:\n'
-        s += '{}\n'.format(fielddisplay(self, 'h', 'load Love number for radial displacement'))
-        s += '{}\n'.format(fielddisplay(self, 'k', 'load Love number for gravitational potential perturbation'))
-        s += '{}\n'.format(fielddisplay(self, 'l', 'load Love number for horizontal displacements'))
-        s += '{}\n'.format(fielddisplay(self, 'th', 'tidal load Love number (deg 2)'))
-        s += '{}\n'.format(fielddisplay(self, 'tk', 'tidal load Love number (deg 2)'))
-        s += '{}\n'.format(fielddisplay(self, 'tk2secular', 'secular fluid Love number'))
-        return s
-    #}}}
-
-    def marshall(self, prefix, md, fid): #{{{
+    def marshall(self, prefix, md, fid):  #{{{
         WriteData(fid, prefix, 'object', self, 'fieldname', 'h', 'name', 'md.solidearth.lovenumbers.h', 'format', 'DoubleMat', 'mattype', 1)
         WriteData(fid, prefix, 'object', self, 'fieldname', 'k', 'name', 'md.solidearth.lovenumbers.k', 'format', 'DoubleMat', 'mattype', 1)
@@ -88,7 +110,14 @@
         WriteData(fid, prefix, 'object', self, 'fieldname', 'tl', 'name', 'md.solidearth.lovenumbers.tl', 'format', 'DoubleMat', 'mattype', 1)
         WriteData(fid, prefix, 'object', self, 'data', self.tk2secular, 'fieldname', 'lovenumbers.tk2secular', 'format', 'Double')
+
+        if (self.istime):
+            scale = md.constants.yts
+        else:
+            scale = 1.0 / md.constants.yts
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'istime', 'name', 'md.solidearth.lovenumbers.istime', 'format', 'Boolean')
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'timefreq', 'name', 'md.solidearth.lovenumbers.timefreq', 'format', 'DoubleMat', 'mattype', 1, 'scale', scale);
     #}}}
 
-    def extrude(self, md): #{{{
+    def extrude(self, md):  #{{{
         return
 #}}}
Index: issm/trunk/src/m/classes/mask.js
===================================================================
--- issm/trunk/src/m/classes/mask.js	(revision 25994)
+++ issm/trunk/src/m/classes/mask.js	(revision 26744)
@@ -7,6 +7,6 @@
 	//properties 
 	// {{{
-		this.ocean_levelset                           = NaN;
-		this.ice_levelset                           = NaN;
+		this.ocean_levelset	= NaN;
+		this.ice_levelset	= NaN;
 		//}}}
 	//methods 
@@ -14,8 +14,8 @@
 		} // }}}
 		this.disp = function () { //{{{
-			console.log(sprintf("   mask:")); 
+			console.log(sprintf("   masks:")); 
 
-			fielddisplay(this,"ocean_levelset","presence of ocean if < 0, coastline/grounding line if = 0, no ocean if > 0");
-			fielddisplay(this,"ice_levelset","presence of ice if < 0, icefront position if = 0, no ice if > 0");
+			fielddisplay(this,'ocean_levelset','presence of ocean if < 0, coastline/grounding line if = 0, no ocean if > 0');
+			fielddisplay(this,'ice_levelset','presence of ice if < 0, icefront position if = 0, no ice if > 0');
 		} //}}}
 		this.extrude = function(md) {//{{{
@@ -28,4 +28,5 @@
 		} //}}}
 		this.checkconsistency = function(md,solution,analyses){ //{{{
+			if (solution=='LoveSolution') return;
 
 			checkfield(md,'fieldname','mask.ocean_levelset','size',[md.mesh.numberofvertices, 1]);
@@ -46,4 +47,3 @@
 		this.fix=function() { //{{{
 		}//}}}
-
 }
